#lang scheme

; Author: Leonie Dreschler-Fischer

(require (lib "scheme-tests.ss" "test-engine"))

; (length (subs xs)) = (expt 2 (length xs))
(define (subs xs)
   (if (null? xs) '(())
       (let ((head (car xs))
             (tail (cdr xs)))
       (append (subs tail)
               (map (curry cons head)
                    (subs tail))))))

(check-expect 
 (subs '(1 2 3))
 '(() (3) (2) (2 3) (1) 
 (1 3) (1 2) (1 2 3))
 )

(check-expect 
 (length(subs '(1 2 3))) 
 (expt 2 (length '(1 2 3)))) 

(define denominations '((Hdollar 50) 
  (Quarter 25) (Dime 10) (Nickel 5) (Cent 1))) 

(define (count-change amount)
  (cc amount denominations)) 
(define (cc a ds)
   (cond ((= a 0) 1)
         ((null? ds) 0)
         ((< a 0) 0)
         (else 
          (let ((coin1 (cadr (car ds)))
                (other-coins (cdr ds)))
            (+ (cc (- a coin1) ds) 
               (cc  a other-coins))))))
