(module plotter-module mzscheme
  (provide plot splot setxOrig setyOrig setxZoom setyZoom showAxes step-color
          ) 
; plot functions in the xy-plane
 (require lang/plt-pretty-big
          htdp/graphing
          se3-bib/tools-module)

  (define *the-color* 'red) 
  (define *the-color-index* 0) 
  (define (step-color)
    (let ((colors '(red green blue )))
      (set! *the-color-index* (add1 *the-color-index*))
      (set! *the-color*
            (list-ref 
             colors 
             (remainder *the-color-index* (length colors))))
      *the-color*))
      
  #|Das Plot-Paket zeichnet den Ursprung links unten und skaliert die Achsen nicht.
Daher kann das Bild hier transponiert werden.|#
  (define *xOrig* 0.0)
  (define *yOrig* 0.0)
  (define *xZoom* 1.0)
  (define *yZoom* 1.0)
  
  (define (setxOrig newX)
    (set! *xOrig* newX))
  
  (define (setyOrig newY)
    (set! *yOrig* newY))
  
  (define (setxZoom newX)
    (set! *xZoom* newX))
  
  (define (setyZoom newY)
    (set! *yZoom* newY))
  
  (define (transform f)
    (lambda (x)
      (+ (* (f (- (/ x *xZoom*)
                  *xOrig*))
            *yZoom*)
         *yOrig*)
      ))
                     
  (define (plot f )
    (graph-fun (transform f) *the-color*)
    (step-color)
    #t
  )
  
  (define (splot f) 
    (graph-line f *the-color*)
    (step-color)#t
  )
  
  (define (showAxes)
    (plot (always 0)); x
    (plot (lambda (x) (if (< (abs x) 0.000001)
                          (* 1000.0 x *xZoom*) 
                          (* 1000.0 *xZoom*)
                          ))); y
    )
  )
; test: (plot sin)