(module prologInScheme swindle
  ;;;; some predefined prolog predicates by Leonie Dreschler-Fischer
  ;;;; exports all functions from the prolog library
  (require 
   swindle/setf
   swindle/misc
   (all-except 
    se3-bib/tools-module
    mappend  every some last concat )   
   (lib "unify.ss" "se3-bib" "prolog")
   (lib "prologDB.ss" "se3-bib" "prolog")
   (lib "pattern-matching-module.ss"  "se3-bib")
    (lib "prolog.ss" "se3-bib" "prolog")
)
  
  (provide 
   (all-from swindle/setf)
   (all-from swindle/misc)
   (all-from se3-bib/tools-module)
   (all-from  (lib "unify.ss" "se3-bib" "prolog"))
   (all-from (lib "prologDB.ss" "se3-bib" "prolog"))
     (all-from (lib "prolog.ss"  "se3-bib" "prolog"))
   (all-from (lib "pattern-matching-module.ss" "se3-bib"))
   )
  
  ; some predefined predicates
  
  ; equality
  (<- (= ?x ?x)) ; do the clauses unify?
  (<- (!= ?x ?y) :-
      (not = ?x ?y) ); do the clauses not unify?
  
  ; list processing
  (<- (member ?item (?item . ?rest)))
  (<- (member ?item (?x . ?rest)) 
      :-(member ?item ?rest))
  
  ; functional predicates, require scheme functions
  
  ; (length list length-of-x)
  (<- (length () 0))
  (<- (length (?x . ?rest) ?len) :- 
      (length ?rest ?lenR) 
      (is ?len (+ 1 ?lenR)))
  
  ; numbers
  
  ; (between: is x larger than a and smaller than b?
  (<- (between ?a ?x ?b) :- 
      (test (< ?a ?x ?b)))
  
  ;
  
  )
